#include "OpenFileDialog.h"
#include "ActionIDs.h"

OpenFileDialog::OpenFileDialog(){
	BuildMenu();
}
popup::Menu&OpenFileDialog::GetMenu(){
	return menu;
}
void OpenFileDialog::ChangePath(std::string newPath){
	if(newPath==""){
		path="/"; //This is an edge case. We can't use the empty string to indicate a valid path.
	} else {
		path=newPath;
	}
	BuildMenu();
}

void OpenFileDialog::BuildMenu(){
	menu.Clear();
	menu["Select "+path].SetID(SELECTED_FOLDER);
	menu[""].Enable(false);
	if(path!="/"){
		menu[".."].SetID(GO_BACK);
	}
	for(auto&dir:std::filesystem::directory_iterator(path)){
		if(dir.is_directory()){
			std::filesystem::path filename = dir.path().filename();
			menu[filename.string()].SetID(CHANGE_LOAD_PATH);
		}
	}
	menu.SetTable(1,std::min(20,menu.GetChildrenCount()));
	menu.Build();
}