#pragma once
#include "olcPixelGameEngine.h"

class FiestaOnlineEditor;

class Window{
private:
	vi2d pos;
	Decal*decWindow;
	const int headerHeight=12;
	bool dragging=false;
	vf2d dragPoint;
	bool canClose=false;
	bool closed=false;
protected:
	vi2d size;
	Sprite*sprWindow;
	static Window*focusedWindow;
	std::string windowTitle="";
public:
	Window(FiestaOnlineEditor*pge,std::string windowTitle,vi2d pos,vi2d size);
	void InternalUpdate(FiestaOnlineEditor*pge,float fElapsedTime);
	virtual void Update(FiestaOnlineEditor*pge,float fElapsedTime)=0;
	virtual void Refresh(FiestaOnlineEditor*pge)=0;
	void InternalRefresh(FiestaOnlineEditor*pge);
	void Draw(FiestaOnlineEditor*pge);
	bool IsFocusedWindow();
	static void SetFocusedWindow(Window*w);
	void Cleanup();
	bool IsInBounds(vf2d point);
	void InternalMouseFocus(FiestaOnlineEditor*pge);
	virtual void MouseFocus(FiestaOnlineEditor*pge);
	bool IsClosed();
};